Bug 446864 - freeradius is broken
freeradius is broken
Product: Fedora
Classification: Fedora
Component: freeradius (Show other bugs)
All Linux
low Severity medium
: ---
: ---
Assigned To: John Dennis
Fedora Extras Quality Assurance
: Reopened
Depends On: 448743
  Show dependency treegraph
Reported: 2008-05-16 10:46 EDT by Phil Mayers
Modified: 2009-07-15 04:24 EDT (History)
3 users (show)

See Also:
Fixed In Version: 2.0.3-3.fc9
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2009-07-15 04:24:16 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
gdb trace (1.77 KB, text/plain)
2008-05-16 10:46 EDT, Phil Mayers
no flags Details

  None (edit)
Description Phil Mayers 2008-05-16 10:46:11 EDT
Description of problem:

FreeRadius 2.0.2 does not work on a default install of Fedora 9. Specifically,
it seems to fail to look up the default port for radius in /etc/services and
ends up listening on a random UDP port.

Speculation on the FreeRadius list is that this is a bug in gcc related to

Version-Release number of selected component (if applicable):


How reproducible:


Steps to Reproduce:
1. Install freeradius
1a. comment out the broken "sql.conf" and "sqlcounter.conf" includes in
2. service radiusd start
3. lsof -i :1812 - returns nothing
4. lsof -p `cat /var/run/radiusd.pid` - shows radiusd listening on random ports

Actual results:

Radius server fails

Expected results:

Radius server works

Additional info:

This can be worked around by changing "port = 0" to "port = 1812" in the listen
sections of radiusd.conf but THIS IS NOT A FIX; gcc seems to be optimising stuff
away that it SHOULD NOT BE

I will attach a trace of a gdb session - you can clearly see the getservbyname
call failing as the return value is optimised away
Comment 1 Phil Mayers 2008-05-16 10:46:11 EDT
Created attachment 305691 [details]
gdb trace
Comment 2 Phil Mayers 2008-05-16 10:47:27 EDT
Sorry, I omitted the link to the discussion on the FreeRadius list:

Comment 3 John Dennis 2008-05-16 11:12:59 EDT
Thank you Phil for your work on this. Actually just this morning I became aware
the "FreeRADIUS 2 not listening on right port" thread was actually an F-9 issue.
I do skim the list, but because of the high traffic only read what seems
relevant and had initially skipped this thread. I will immediately investigate.
The short term workaround might be build the package without optimization and
send it out as an update. FYI, my daughter is graduating from college this
weekend and I have family commitments starting this afternoon and continuing
through Tuesday, I'll try to push out a new package before I have to leave
today, but there is an excellent chance it won't happen until I return, I'll see
what I can do.

FWIW, there were no source code changes in our RPM, the only real difference was
in packaging, splitting things up into smaller sub-packages to reduce dependency
bloat, but so far no source code changes have been applied to the 2.0.x series.
Comment 4 Fedora Update System 2008-05-16 13:09:58 EDT
freeradius-2.0.3-3.fc9 has been submitted as an update for Fedora 9
Comment 5 John Dennis 2008-05-16 13:26:56 EDT
I have rebuilt the package without compiler optimization. Due to time
constraints on my end I am unable to test the new package but felt it was
worthwhile to push it out as an update ASAP based on feedback from the list
which confirms building without optimization fixes the problem. Upon my return I
will investigate the root cause of the original problem.
Comment 6 Fedora Update System 2008-05-17 18:19:40 EDT
freeradius-2.0.3-3.fc9 has been pushed to the Fedora 9 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 7 John Dennis 2008-05-20 13:01:04 EDT
This should not have been automatically closed. I'm re-opening it until we
understand the root cause of the problem and have re-released a package with
optimization on.
Comment 8 John Dennis 2008-05-28 11:28:49 EDT
I have analyzed the generated machine code for the function fr_socket on i386
with -O2 optimization. It does appear the assignment of the port value in the
saddr_in struct is not generating code. I have created a new bug report against
GCC to track this issues (bug #448743). You may find complete analysis in that
bug report. 
Comment 9 Fedora Update System 2008-06-26 12:12:22 EDT
freeradius-2.0.5-1.fc9 has been submitted as an update for Fedora 9
Comment 10 Fedora Update System 2008-06-27 15:34:38 EDT
freeradius-2.0.5-1.fc9 has been pushed to the Fedora 9 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update freeradius'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/F9/FEDORA-2008-5753
Comment 11 Bug Zapper 2009-06-09 20:54:01 EDT
This message is a reminder that Fedora 9 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 9.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '9'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 9's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 9 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
Comment 12 Bug Zapper 2009-07-15 04:24:16 EDT
Fedora 9 changed to end-of-life (EOL) status on 2009-07-10. Fedora 9 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.